import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../../../common";
export type InitializePayloadStruct = {
    feeTiers: PromiseOrValue<BigNumberish>[];
    token0: PromiseOrValue<string>;
    token1: PromiseOrValue<string>;
    owner: PromiseOrValue<string>;
    init0: PromiseOrValue<BigNumberish>;
    init1: PromiseOrValue<BigNumberish>;
    manager: PromiseOrValue<string>;
    routers: PromiseOrValue<string>[];
};
export type InitializePayloadStructOutput = [
    number[],
    string,
    string,
    string,
    BigNumber,
    BigNumber,
    string,
    string[]
] & {
    feeTiers: number[];
    token0: string;
    token1: string;
    owner: string;
    init0: BigNumber;
    init1: BigNumber;
    manager: string;
    routers: string[];
};
export interface IArrakisV2FactoryInterface extends utils.Interface {
    functions: {
        "arrakisV2Beacon()": FunctionFragment;
        "deployVault((uint24[],address,address,address,uint256,uint256,address,address[]),bool)": FunctionFragment;
        "getProxyAdmin(address)": FunctionFragment;
        "getProxyImplementation(address)": FunctionFragment;
        "getTokenName(address,address)": FunctionFragment;
        "makeVaultsImmutable(address[])": FunctionFragment;
        "numVaults()": FunctionFragment;
        "upgradeVaults(address[])": FunctionFragment;
        "upgradeVaultsAndCall(address[],bytes[])": FunctionFragment;
        "vaults(uint256,uint256)": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "arrakisV2Beacon" | "deployVault" | "getProxyAdmin" | "getProxyImplementation" | "getTokenName" | "makeVaultsImmutable" | "numVaults" | "upgradeVaults" | "upgradeVaultsAndCall" | "vaults"): FunctionFragment;
    encodeFunctionData(functionFragment: "arrakisV2Beacon", values?: undefined): string;
    encodeFunctionData(functionFragment: "deployVault", values: [InitializePayloadStruct, PromiseOrValue<boolean>]): string;
    encodeFunctionData(functionFragment: "getProxyAdmin", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "getProxyImplementation", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "getTokenName", values: [PromiseOrValue<string>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "makeVaultsImmutable", values: [PromiseOrValue<string>[]]): string;
    encodeFunctionData(functionFragment: "numVaults", values?: undefined): string;
    encodeFunctionData(functionFragment: "upgradeVaults", values: [PromiseOrValue<string>[]]): string;
    encodeFunctionData(functionFragment: "upgradeVaultsAndCall", values: [PromiseOrValue<string>[], PromiseOrValue<BytesLike>[]]): string;
    encodeFunctionData(functionFragment: "vaults", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]): string;
    decodeFunctionResult(functionFragment: "arrakisV2Beacon", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "deployVault", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getProxyAdmin", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getProxyImplementation", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getTokenName", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "makeVaultsImmutable", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "numVaults", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "upgradeVaults", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "upgradeVaultsAndCall", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "vaults", data: BytesLike): Result;
    events: {
        "InitFactory(address)": EventFragment;
        "VaultCreated(address,address)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "InitFactory"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "VaultCreated"): EventFragment;
}
export interface InitFactoryEventObject {
    owner: string;
}
export type InitFactoryEvent = TypedEvent<[string], InitFactoryEventObject>;
export type InitFactoryEventFilter = TypedEventFilter<InitFactoryEvent>;
export interface VaultCreatedEventObject {
    manager: string;
    vault: string;
}
export type VaultCreatedEvent = TypedEvent<[
    string,
    string
], VaultCreatedEventObject>;
export type VaultCreatedEventFilter = TypedEventFilter<VaultCreatedEvent>;
export interface IArrakisV2Factory extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: IArrakisV2FactoryInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        arrakisV2Beacon(overrides?: CallOverrides): Promise<[string]>;
        deployVault(params_: InitializePayloadStruct, isBeacon_: PromiseOrValue<boolean>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        getProxyAdmin(proxy: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[string]>;
        getProxyImplementation(proxy: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[string]>;
        getTokenName(token0_: PromiseOrValue<string>, token1_: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[string]>;
        makeVaultsImmutable(vaults_: PromiseOrValue<string>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        numVaults(overrides?: CallOverrides): Promise<[BigNumber]>;
        upgradeVaults(vaults_: PromiseOrValue<string>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        upgradeVaultsAndCall(vaults_: PromiseOrValue<string>[], datas_: PromiseOrValue<BytesLike>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        vaults(startIndex_: PromiseOrValue<BigNumberish>, endIndex_: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[string[]]>;
    };
    arrakisV2Beacon(overrides?: CallOverrides): Promise<string>;
    deployVault(params_: InitializePayloadStruct, isBeacon_: PromiseOrValue<boolean>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    getProxyAdmin(proxy: PromiseOrValue<string>, overrides?: CallOverrides): Promise<string>;
    getProxyImplementation(proxy: PromiseOrValue<string>, overrides?: CallOverrides): Promise<string>;
    getTokenName(token0_: PromiseOrValue<string>, token1_: PromiseOrValue<string>, overrides?: CallOverrides): Promise<string>;
    makeVaultsImmutable(vaults_: PromiseOrValue<string>[], overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    numVaults(overrides?: CallOverrides): Promise<BigNumber>;
    upgradeVaults(vaults_: PromiseOrValue<string>[], overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    upgradeVaultsAndCall(vaults_: PromiseOrValue<string>[], datas_: PromiseOrValue<BytesLike>[], overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    vaults(startIndex_: PromiseOrValue<BigNumberish>, endIndex_: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<string[]>;
    callStatic: {
        arrakisV2Beacon(overrides?: CallOverrides): Promise<string>;
        deployVault(params_: InitializePayloadStruct, isBeacon_: PromiseOrValue<boolean>, overrides?: CallOverrides): Promise<string>;
        getProxyAdmin(proxy: PromiseOrValue<string>, overrides?: CallOverrides): Promise<string>;
        getProxyImplementation(proxy: PromiseOrValue<string>, overrides?: CallOverrides): Promise<string>;
        getTokenName(token0_: PromiseOrValue<string>, token1_: PromiseOrValue<string>, overrides?: CallOverrides): Promise<string>;
        makeVaultsImmutable(vaults_: PromiseOrValue<string>[], overrides?: CallOverrides): Promise<void>;
        numVaults(overrides?: CallOverrides): Promise<BigNumber>;
        upgradeVaults(vaults_: PromiseOrValue<string>[], overrides?: CallOverrides): Promise<void>;
        upgradeVaultsAndCall(vaults_: PromiseOrValue<string>[], datas_: PromiseOrValue<BytesLike>[], overrides?: CallOverrides): Promise<void>;
        vaults(startIndex_: PromiseOrValue<BigNumberish>, endIndex_: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<string[]>;
    };
    filters: {
        "InitFactory(address)"(owner?: null): InitFactoryEventFilter;
        InitFactory(owner?: null): InitFactoryEventFilter;
        "VaultCreated(address,address)"(manager?: PromiseOrValue<string> | null, vault?: PromiseOrValue<string> | null): VaultCreatedEventFilter;
        VaultCreated(manager?: PromiseOrValue<string> | null, vault?: PromiseOrValue<string> | null): VaultCreatedEventFilter;
    };
    estimateGas: {
        arrakisV2Beacon(overrides?: CallOverrides): Promise<BigNumber>;
        deployVault(params_: InitializePayloadStruct, isBeacon_: PromiseOrValue<boolean>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        getProxyAdmin(proxy: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        getProxyImplementation(proxy: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        getTokenName(token0_: PromiseOrValue<string>, token1_: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        makeVaultsImmutable(vaults_: PromiseOrValue<string>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        numVaults(overrides?: CallOverrides): Promise<BigNumber>;
        upgradeVaults(vaults_: PromiseOrValue<string>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        upgradeVaultsAndCall(vaults_: PromiseOrValue<string>[], datas_: PromiseOrValue<BytesLike>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        vaults(startIndex_: PromiseOrValue<BigNumberish>, endIndex_: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        arrakisV2Beacon(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        deployVault(params_: InitializePayloadStruct, isBeacon_: PromiseOrValue<boolean>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        getProxyAdmin(proxy: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getProxyImplementation(proxy: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getTokenName(token0_: PromiseOrValue<string>, token1_: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        makeVaultsImmutable(vaults_: PromiseOrValue<string>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        numVaults(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        upgradeVaults(vaults_: PromiseOrValue<string>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        upgradeVaultsAndCall(vaults_: PromiseOrValue<string>[], datas_: PromiseOrValue<BytesLike>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        vaults(startIndex_: PromiseOrValue<BigNumberish>, endIndex_: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
